window.watchface = {};
var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var stepCount = 0;
var previousDate = 0
window.watchface.imgbgpng = new Image();
    window.watchface.imgbgpng.src = "bg.png";
window.watchface.imgmonthpng = new Image();
    window.watchface.imgmonthpng.src = "month.png";
window.watchface.imgsecpng = new Image();
    window.watchface.imgsecpng.src = "sec.png";
window.watchface.imgsteppng = new Image();
    window.watchface.imgsteppng.src = "step.png";
window.watchface.imgbatterypng = new Image();
    window.watchface.imgbatterypng.src = "battery.png";
window.watchface.imghspng = new Image();
    window.watchface.imghspng.src = "hs.png";
window.watchface.imghpng = new Image();
    window.watchface.imghpng.src = "h.png";
window.watchface.imgmspng = new Image();
    window.watchface.imgmspng.src = "ms.png";
window.watchface.imgmpng = new Image();
    window.watchface.imgmpng.src = "m.png";
window.watchface.imgsamwatchdesign3backspng = new Image();
    window.watchface.imgsamwatchdesign3backspng.src = "samwatchdesign3backs.png";

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    if (previousDate === 0) previousDate = date;
    if (previousDate != date) {
        previousDate = date;
        //webapi.pedometer.prevSteps = webapi.pedometer.steps;
        //webapi.pedometer.steps = 0;
    }
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    context.drawImage(window.watchface.imgbgpng, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px HoonModernBold";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#2E2E2E";
    text = date.getDate();
    context.fillText(text, 247, 180);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "10px HoonModernBold";
    context.textAlign = "left";
    context.textBaseline="middle";
    context.fillStyle = "#F0ECE3";
    text = "Text";
    context.fillText(text, 177, 232);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "10px HoonModernBold";
    context.textAlign = "left";
    context.textBaseline="middle";
    context.fillStyle = "#F0ECE3";
    text = "Text";
    context.fillText(text, 177, 242);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((date.getMonth() + 1 - 0.000000) / (12.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgmonthpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgsecpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = null
    context.translate(180, 237);
    context.rotate(angle);
    context.drawImage(window.watchface.imgsteppng, -47, -47, 94, 94);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((Math.floor(battery.level*100) - 0.000000) / (100.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 236);
    context.rotate(angle);
    context.drawImage(window.watchface.imgbatterypng, -47, -47, 94, 94);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 181);
    context.rotate(angle);
    context.drawImage(window.watchface.imghspng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imghpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 181);
    context.rotate(angle);
    context.drawImage(window.watchface.imgmspng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgmpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.drawImage(window.watchface.imgsamwatchdesign3backspng, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
